---------------------------------------------------------------------------------
-- Filename : rs232_tx.vhd
-- ========== 
-- 
-- Beschreibung : Versand von Daten ueber die RS232 Schnittstelle
-- ==============
--
-- Autoren : Martin Perner, Schwarz Manfred
-- =========
----------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

use work.common_pkg.all;
use work.core_pkg.all;
use work.extension_uart_pkg.all;

entity rs232_tx is
	generic	(
		-- active reset value
		RESET_VALUE : std_logic
		);
	port(
		--System inputs
		sys_clk : in std_logic;
		sys_res_n : in std_logic;

		--Bus
		bus_tx : out std_logic;

		--From/to extension
		new_tx_data : in std_logic;
		tx_data : in uart_data;
		tx_rdy : out std_logic;
		bd_rate : in baud_rate_l;
		stop_bit : in std_logic
	);

end rs232_tx;
